# Record Class CJ1Location

java.lang.Object
java.lang.Record
com.io7m.cardant.protocol.inventory.json.internal.CJ1Location

All Implemented Interfaces:
  `CJ1ValueType`

@JsonClassDescription("A location.") public record CJ1Location(UUID id, Optional<UUID> parent, List<String> path, OffsetDateTime timeCreated, OffsetDateTime timeUpdated, Map<CJ1TypeRecordFieldIdentifier,CJ1MetadataType> metadata, List<CJ1AttachmentItem> attachments, Set<CJ1TypeRecordIdentifier> types) extends Record implements CJ1ValueType

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CJ1Location(UUID id, Optional<UUID> parent, List<String> path, OffsetDateTime timeCreated, OffsetDateTime timeUpdated, Map<CJ1TypeRecordFieldIdentifier,CJ1MetadataType> metadata, List<CJ1AttachmentItem> attachments, Set<CJ1TypeRecordIdentifier> types)`
  Creates an instance of a `CJ1Location` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<CJ1AttachmentItem>`
  `attachments()`
  Returns the value of the `attachments` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `UUID`
  `id()`
  Returns the value of the `id` record component.
  `Map<CJ1TypeRecordFieldIdentifier,CJ1MetadataType>`
  `metadata()`
  Returns the value of the `metadata` record component.
  `Optional<UUID>`
  `parent()`
  Returns the value of the `parent` record component.
  `List<String>`
  `path()`
  Returns the value of the `path` record component.
  `OffsetDateTime`
  `timeCreated()`
  Returns the value of the `timeCreated` record component.
  `OffsetDateTime`
  `timeUpdated()`
  Returns the value of the `timeUpdated` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Set<CJ1TypeRecordIdentifier>`
  `types()`
  Returns the value of the `types` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CJ1Location

    public CJ1Location(@JsonPropertyDescription("The location ID.") UUID id, @JsonPropertyDescription("The location parent.") Optional<UUID> parent, @JsonPropertyDescription("The location path.") List<String> path, @JsonPropertyDescription("The location creation time.") OffsetDateTime timeCreated, @JsonPropertyDescription("The location most recent update time.") OffsetDateTime timeUpdated, @JsonPropertyDescription("The location metadata.") Map<CJ1TypeRecordFieldIdentifier,CJ1MetadataType> metadata, @JsonPropertyDescription("The location attachments.") List<CJ1AttachmentItem> attachments, @JsonPropertyDescription("The location types.") Set<CJ1TypeRecordIdentifier> types)
    Creates an instance of a `CJ1Location` record class.
    Parameters:
      `id` - the value for the `id` record component
      `parent` - the value for the `parent` record component
      `path` - the value for the `path` record component
      `timeCreated` - the value for the `timeCreated` record component
      `timeUpdated` - the value for the `timeUpdated` record component
      `metadata` - the value for the `metadata` record component
      `attachments` - the value for the `attachments` record component
      `types` - the value for the `types` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### id

    @JsonPropertyDescription("The location ID.") public UUID id()
    Returns the value of the `id` record component.
    Returns:
      the value of the `id` record component

  - ### parent

    @JsonPropertyDescription("The location parent.") public Optional<UUID> parent()
    Returns the value of the `parent` record component.
    Returns:
      the value of the `parent` record component

  - ### path

    @JsonPropertyDescription("The location path.") public List<String> path()
    Returns the value of the `path` record component.
    Returns:
      the value of the `path` record component

  - ### timeCreated

    @JsonPropertyDescription("The location creation time.") public OffsetDateTime timeCreated()
    Returns the value of the `timeCreated` record component.
    Returns:
      the value of the `timeCreated` record component

  - ### timeUpdated

    @JsonPropertyDescription("The location most recent update time.") public OffsetDateTime timeUpdated()
    Returns the value of the `timeUpdated` record component.
    Returns:
      the value of the `timeUpdated` record component

  - ### metadata

    @JsonPropertyDescription("The location metadata.") public Map<CJ1TypeRecordFieldIdentifier,CJ1MetadataType> metadata()
    Returns the value of the `metadata` record component.
    Returns:
      the value of the `metadata` record component

  - ### attachments

    @JsonPropertyDescription("The location attachments.") public List<CJ1AttachmentItem> attachments()
    Returns the value of the `attachments` record component.
    Returns:
      the value of the `attachments` record component

  - ### types

    @JsonPropertyDescription("The location types.") public Set<CJ1TypeRecordIdentifier> types()
    Returns the value of the `types` record component.
    Returns:
      the value of the `types` record component